Clazz.declarePackage ("jalview.analysis");
Clazz.load (null, "jalview.analysis.AlignmentAnnotationUtils", ["java.util.ArrayList", "$.Arrays", "$.BitSet", "$.Collections", "$.HashMap"], function () {
c$ = Clazz.declareType (jalview.analysis, "AlignmentAnnotationUtils");
c$.getShownHiddenTypes = Clazz.defineMethod (c$, "getShownHiddenTypes", 
function (shownTypes, hiddenTypes, annotations, forSequences) {
var visibleGraphGroups = jalview.analysis.AlignmentAnnotationUtils.getVisibleLineGraphGroups (annotations);
var groupLabels =  new java.util.HashMap ();
var addedToShown =  new java.util.ArrayList ();
var addedToHidden =  new java.util.ArrayList ();
for (var aa, $aa = annotations.iterator (); $aa.hasNext () && ((aa = $aa.next ()) || true);) {
if (aa.annotations == null) {
continue;
}if (forSequences != null && (aa.sequenceRef != null && forSequences.contains (aa.sequenceRef))) {
var calcId = aa.getCalcId ();
var labelAsList =  new java.util.ArrayList ();
var displayLabel = aa.label;
labelAsList.add (displayLabel);
if (aa.graph == 2 && aa.graphGroup > -1) {
if (!groupLabels.containsKey (calcId)) {
groupLabels.put (calcId,  new java.util.HashMap ());
}var groupLabelsForCalcId = groupLabels.get (calcId);
if (groupLabelsForCalcId.containsKey (new Integer (aa.graphGroup))) {
if (!groupLabelsForCalcId.get (new Integer (aa.graphGroup)).contains (displayLabel)) {
groupLabelsForCalcId.get (new Integer (aa.graphGroup)).add (displayLabel);
}} else {
groupLabelsForCalcId.put (new Integer (aa.graphGroup), labelAsList);
}} else {
var rememberAs = calcId + "!" + displayLabel;
if (aa.visible && !addedToShown.contains (rememberAs)) {
if (!shownTypes.containsKey (calcId)) {
shownTypes.put (calcId,  new java.util.ArrayList ());
}shownTypes.get (calcId).add (labelAsList);
addedToShown.add (rememberAs);
} else {
if (!aa.visible && !addedToHidden.contains (rememberAs)) {
if (!hiddenTypes.containsKey (calcId)) {
hiddenTypes.put (calcId,  new java.util.ArrayList ());
}hiddenTypes.get (calcId).add (labelAsList);
addedToHidden.add (rememberAs);
}}}}}
for (var calcId, $calcId = groupLabels.keySet ().iterator (); $calcId.hasNext () && ((calcId = $calcId.next ()) || true);) {
for (var group, $group = groupLabels.get (calcId).keySet ().iterator (); $group.hasNext () && ((group = $group.next ()) || true);) {
var groupLabel = groupLabels.get (calcId).get (new Integer (group));
java.util.Collections.sort (groupLabel);
if (visibleGraphGroups.get (group)) {
if (!shownTypes.containsKey (calcId)) {
shownTypes.put (calcId,  new java.util.ArrayList ());
}if (!shownTypes.get (calcId).contains (groupLabel)) {
shownTypes.get (calcId).add (groupLabel);
}} else {
if (!hiddenTypes.containsKey (calcId)) {
hiddenTypes.put (calcId,  new java.util.ArrayList ());
}if (!hiddenTypes.get (calcId).contains (groupLabel)) {
hiddenTypes.get (calcId).add (groupLabel);
}}}
}
}, "java.util.Map,java.util.Map,java.util.List,java.util.List");
c$.getVisibleLineGraphGroups = Clazz.defineMethod (c$, "getVisibleLineGraphGroups", 
function (annotations) {
var result =  new java.util.BitSet ();
for (var ann, $ann = annotations.iterator (); $ann.hasNext () && ((ann = $ann.next ()) || true);) {
if (ann.graph == 2 && ann.visible) {
var gg = ann.graphGroup;
if (gg > -1) {
result.set (gg);
}}}
return result;
}, "java.util.List");
c$.asList = Clazz.defineMethod (c$, "asList", 
function (anns) {
return (anns == null ? java.util.Collections.emptyList () : java.util.Arrays.asList (anns));
}, "~A");
});
