Clazz.declarePackage ("jalview.datamodel");
Clazz.load (["java.util.ArrayList"], "jalview.datamodel.SearchResults", ["java.lang.StringBuilder", "java.util.Arrays"], function () {
c$ = Clazz.decorateAsClass (function () {
this.matches = null;
if (!Clazz.isClassDefined ("jalview.datamodel.SearchResults.Match")) {
jalview.datamodel.SearchResults.$SearchResults$Match$ ();
}
Clazz.instantialize (this, arguments);
}, jalview.datamodel, "SearchResults");
Clazz.prepareFields (c$, function () {
this.matches =  new java.util.ArrayList ();
});
Clazz.defineMethod (c$, "addResult", 
function (seq, start, end) {
this.matches.add (Clazz.innerTypeInstance (jalview.datamodel.SearchResults.Match, this, null, seq, start, end));
}, "jalview.datamodel.SequenceI,~N,~N");
Clazz.defineMethod (c$, "involvesSequence", 
function (sequence) {
var ds = sequence.getDatasetSequence ();
for (var m, $m = this.matches.iterator (); $m.hasNext () && ((m = $m.next ()) || true);) {
if (m.sequence != null && (m.sequence === sequence || m.sequence === ds)) {
return true;
}}
return false;
}, "jalview.datamodel.SequenceI");
Clazz.defineMethod (c$, "getResults", 
function (sequence, start, end) {
if (this.matches.isEmpty ()) {
return null;
}var result = null;
var tmp = null;
var resultLength;
var matchStart = 0;
var matchEnd = 0;
var mfound;
for (var m, $m = this.matches.iterator (); $m.hasNext () && ((m = $m.next ()) || true);) {
mfound = false;
if (m.sequence === sequence) {
mfound = true;
matchStart = sequence.findIndex (m.start) - 1;
matchEnd = sequence.findIndex (m.end) - 1;
} else if (m.sequence === sequence.getDatasetSequence ()) {
mfound = true;
matchStart = sequence.findIndex (m.start) - 1;
matchEnd = sequence.findIndex (m.end) - 1;
}if (mfound) {
if (matchStart <= end && matchEnd >= start) {
if (matchStart < start) {
matchStart = start;
}if (matchEnd > end) {
matchEnd = end;
}if (result == null) {
result =  Clazz.newIntArray (-1, [matchStart, matchEnd]);
} else {
resultLength = result.length;
tmp =  Clazz.newIntArray (resultLength + 2, 0);
System.arraycopy (result, 0, tmp, 0, resultLength);
result = tmp;
result[resultLength] = matchStart;
result[resultLength + 1] = matchEnd;
}} else {
}}}
return result;
}, "jalview.datamodel.SequenceI,~N,~N");
Clazz.defineMethod (c$, "getSize", 
function () {
return this.matches.size ();
});
Clazz.defineMethod (c$, "getResultSequence", 
function (index) {
return this.matches.get (index).sequence;
}, "~N");
Clazz.defineMethod (c$, "getResultStart", 
function (i) {
return this.matches.get (i).start;
}, "~N");
Clazz.defineMethod (c$, "getResultEnd", 
function (i) {
return this.matches.get (i).end;
}, "~N");
Clazz.defineMethod (c$, "isEmpty", 
function () {
return this.matches.isEmpty ();
});
Clazz.defineMethod (c$, "getResults", 
function () {
return this.matches;
});
Clazz.overrideMethod (c$, "toString", 
function () {
var result =  new StringBuilder (256);
for (var m, $m = this.matches.iterator (); $m.hasNext () && ((m = $m.next ()) || true);) {
result.append (m.toString ());
}
return result.toString ();
});
c$.$SearchResults$Match$ = function () {
Clazz.pu$h ();
c$ = Clazz.decorateAsClass (function () {
Clazz.prepareCallback (this, arguments);
this.sequence = null;
this.start = 0;
this.end = 0;
Clazz.instantialize (this, arguments);
}, jalview.datamodel.SearchResults, "Match");
Clazz.makeConstructor (c$, 
function (a, b, c) {
this.sequence = a;
this.start = b;
this.end = c;
}, "jalview.datamodel.SequenceI,~N,~N");
Clazz.defineMethod (c$, "getSequence", 
function () {
return this.sequence;
});
Clazz.defineMethod (c$, "getStart", 
function () {
return this.start;
});
Clazz.defineMethod (c$, "getEnd", 
function () {
return this.end;
});
Clazz.overrideMethod (c$, "toString", 
function () {
var a = this.sequence.getSequence ();
var b = Math.max (this.start - 1, 0);
var c = Math.min (this.end, a.length + 1);
return String.valueOf (java.util.Arrays.copyOfRange (a, b, c));
});
Clazz.defineMethod (c$, "setSequence", 
function (a) {
this.sequence = a;
}, "jalview.datamodel.SequenceI");
c$ = Clazz.p0p ();
};
});
