//
// This software is now distributed according to
// the Lesser Gnu Public License.  Please see
// http://www.gnu.org/copyleft/lesser.txt for
// the details.
//    -- Happy Computing!
//
package com.stevesoft.pat.wrap;

import com.stevesoft.pat.*;

/**
 * This provides a wrapper for javajs.util.SB to capture the output of a
 * replacement.
 */
public class StringBufferWrap implements BasicStringBufferLike
{
  javajs.util.SB sb = new javajs.util.SB();

  public void appendChar(char c)
  {
    sb.appendC(c);
  }

  public void appendStr(String s)
  {
    sb.append(s);
  }

  public int length()
  {
    return sb.length();
  }

  public String toString()
  {
    return sb.toString();
  }

  public StringLike toStringLike()
  {
    try {
    	return (StringLike) Class.forName("com.stevesoft.pat.wrap.StringWrap").getConstructor(String.class).newInstance(sb.toString());
    } catch (Exception e) {
    	return  null;
    }
  }

  public Object unwrap()
  {
    return sb;
  }
}
